/*
 * main.c
 * code: SASANO Takayoshi
 * --- public domain, no warranty
 */

#include "common.h"

/* $B%o!<%/%(%j%"(B */
LOCAL	WorkArea	Wk;

/* $B%I%i%$%P!&%(%s%H%j%]%$%s%H(B */
EXPORT	ERR	main(Bool start, TC *arg)
{
	ERR	err;
	WorkArea	*wk = &Wk;

	if (!start) {
		err = ER_OK;
		goto fin3;
	}

	/* $B%o!<%/%(%j%"$N=i4|2=(B */
	memset(wk, 0, sizeof(Wk));
	wk->device_did = wk->device_iid = wk->device_pid = -1;

	/* $B%G!<%?=hM}%?%9%/$N5/F0(B */
	err = data_start(wk);
	if (err < ER_OK) goto fin0;

	/* USB$B%G%P%$%94IM}%?%9%/$N5/F0(B */
	err = device_start(wk);
	if (err < ER_OK) goto fin1;

	err = ER_OK;
	goto fin0;

 fin3:
	device_detach(wk, NULL, NULL);
/*fin2:*/
	device_finish(wk);
 fin1:
	data_finish(wk);
 fin0:
	return err;
}
